React = window.React ? throw new Error 'react-transformer needs a global "React"'

mergeInto = ->
  for argument in Array::slice.call arguments, 1 when argument?
    for key, value of argument
      arguments[0][key] = value
  arguments[0]

Translator = React.createClass
  displayName: 'Translator'

  statics:
    CHANGE_EVENT: 'react-translator:change-strings'

    strings: {}

    setStrings: (newStrings) ->
      mergeInto @strings, newStrings
      @dispatchChange()

    replaceStrings: (newStrings) ->
      @strings = newStrings
      @dispatchChange()

    dispatchChange: ->
      e = document.createEvent 'CustomEvent'
      e.initCustomEvent @CHANGE_EVENT, true, true, @strings
      document.dispatchEvent e

    getString: (segments, object = @strings) ->
      if typeof segments is 'string'
        segments = segments.split '.'

      try [object, segments...].reduce (result, key) ->
        result[key]

  getInitialState: ->
    strings: Translator.strings

  getDefaultProps: ->
    tag: React.DOM.span

  componentDidMount: ->
    document.addEventListener Translator.CHANGE_EVENT, this

  handleEvent: (e) ->
    if e.type is Translator.CHANGE_EVENT
      @setState strings: e.detail

  componentWillUnmount: ->
    document.removeEventListener Translator.CHANGE_EVENT, this

  render: ->
    tag = @props.tag
    if typeof tag is 'string'
      tag = React.DOM[tag]

    # Any strings passed in as props override the global ones referenced in state.
    strings = mergeInto {}, @state.strings, @props.strings

    result = Translator.getString @props.children, strings

    if typeof result is 'function'
      result = result.call this

    @transferPropsTo tag null, result

module.exports = Translator
